searchNodes=[{"doc":"Functions for interacting with systemd features.","ref":"systemd.html","title":"systemd","type":"module"},{"doc":"Check if system was booted with systemd. Note that all other functions in this module are safe to call even on non-systemd boots (even on non-systemd platforms). You should NOT protect them with a call to this function. Also note that this checks wheter the system, not the user session, is controlled by systemd. However other functions will work for both - user and system services.","ref":"systemd.html#booted/0","title":"systemd.booted/0","type":"function"},{"doc":"Removes given named filedescriptors from the store.","ref":"systemd.html#clear_fds/1","title":"systemd.clear_fds/1","type":"function"},{"doc":"","ref":"systemd.html#is_journal/1","title":"systemd.is_journal/1","type":"function"},{"doc":"Returns list of file descriptors passed to the application by systemd.","ref":"systemd.html#listen_fds/0","title":"systemd.listen_fds/0","type":"function"},{"doc":"Send notification to the systemd socket. Arguments notify(ready) Notify that application is ready for work. If used with Type=notify in systemd.service(5) file then it will block systemctl start until this is called. notify(stopping) Notify that application has already started shutting down, but is not yet ready to stop. For example when you want to do connection draining or you have to do some cleaning before fully stopping. This will be automatically set for you in systemd 's application prep_stop/1 step, so user do not need to call it manually. notify(reloading) Notify that application is reloading. It is left up to user what is considered reloading and handle this call manually. notify({errno, Errno :: integer()}) Notify that application encountered Errno in C's errno format. Implemented only for feature parity. notify({buserror, Error :: unicode:chardata()}) Notify about DBus error. notify({extend_timeout, {integer(), erlang:time_unit()}}) Request extension of timeout for sending notify(ready) . This is useful in case of setups that are taking more time than originally expected, for example because of retries in connecting to external service. This message must be sent within original timeout. Return value Returns ok on success or if the message was ignored because there is no systemd notify socket. Only error that can be returned as 0.6.0 is when the file descriptors are passed and at least one of them is not correct file descriptor (for example it is closed), then this call will return {error, bad_descriptor} .","ref":"systemd.html#notify/1","title":"systemd.notify/1","type":"function"},{"doc":"Returns child spec for task that will inform systemd that application is ready. This is helper function that will return supervisor:child_spec/0 map that contains temporary job that will notify systemd about application readiness. This is meant to be inserted into your supervison tree when application is ready (usually at the end).","ref":"systemd.html#ready/0","title":"systemd.ready/0","type":"function"},{"doc":"","ref":"systemd.html#ready/1","title":"systemd.ready/1","type":"function"},{"doc":"Equivalent to reload([]) .","ref":"systemd.html#reload/0","title":"systemd.reload/0","type":"function"},{"doc":"Restart VM with informing the systemd about reload. This is esentially the same as init:restart(Opts) with the difference that it will inform the systemd that the system is reloading instead of shutting down. If you use init:restart/{0,1} anywhere in your application you need to change it to this function otherwise your application may be forced to exit by systemd on reloads.","ref":"systemd.html#reload/1","title":"systemd.reload/1","type":"function"},{"doc":"","ref":"systemd.html#set_status/1","title":"systemd.set_status/1","type":"function"},{"doc":"Send given file descriptors to supervisor for storage between VM restarts. Warning This currently assumes that the currently used ABI is using 32-bit int s. This is true for Linux at least for IA-32, x86-64, AArch64, AArch32, SPARC, OpenRISC, and RISC-V (required by POSIX). So while that shouldn't cause any problems, beware, that currently it may fail on some exotic platforms.","ref":"systemd.html#store_fds/1","title":"systemd.store_fds/1","type":"function"},{"doc":"Unset environment variables for given subsystem. Most environment variables will be cleaned on startup by default. To prevent such behaviour set unset_env application variable to false . unset_env(notify) Unset variables used by notify/1 . This call will be done automatically when the unset_env application option is set (default). It is highly encouraged to unset these variables to prevent them from being passed to subprocesses. unset_env(watchdog) Unset variables used by watchdog/1 . This call will be done automatically when the unset_env application option is set (default). It is highly encouraged to unset these variables to prevent them from being passed to subprocesses. unset_env(listen_fds) Unset variables used by listen_fds/0 . After that all subsequent calls to listen_fds will return empty list. It is highly encouraged to unset these variables to prevent them from being passed to the subprocesses.","ref":"systemd.html#unset_env/1","title":"systemd.unset_env/1","type":"function"},{"doc":"Manage watchdog process. By default systemd will handle Watchdog process automatically for you. Arguments watchdog(state) -&gt; sd_timeout() Returns state of the Watchdog process. Which either be integer representing timeout in microseconds or false if Watchdog process is disabled. watchdog(enable) -&gt; ok Enable Watchdog process. Watchdog process is automatically enabled when needed after startup, so this will be only needed if user manually called watchdog(disable) . watchdog(disable) -&gt; ok Disable Watchdog process. This will cause no keep-alive messages to be sent. watchdog(trigger) -&gt; ok Manually send keep-alive message to the Watchdog. It will not reset timer and will not disturb regular process pinging. Options watchdog_scale Divider of the timeout to send messages more often than this is required to prevent any jitter. Defaults to 2 which will send messages twice as often as needed. watchdog_check Function (specified as 0-ary function or mfa() ) that will be ran before pinging watchdog process. Such function should return true if the application is in functioning state and false otherwise. Defaults to function that always return true .","ref":"systemd.html#watchdog/1","title":"systemd.watchdog/1","type":"function"},{"doc":"","ref":"systemd.html#t:fd/0","title":"systemd.fd/0","type":"type"},{"doc":"","ref":"systemd.html#t:sd_timeout/0","title":"systemd.sd_timeout/0","type":"type"},{"doc":"","ref":"systemd.html#t:state/0","title":"systemd.state/0","type":"type"},{"doc":"Logger handler for sending messages to systemd's journal . Usage Run this after the systemd application is started: logger : add_handler ( journal , systemd_journal_h , \#{ } ) . Options fields :: [field_definition()] Contains list of all fields that will be passed to the journald . Defaults to: [ syslog_timestamp , syslog_pid , syslog_identifier , priority , { &quot;ERL_PID&quot; , pid } , { &quot;CODE_FILE&quot; , file } , { &quot;CODE_LINE&quot; , line } , { &quot;CODE_MFA&quot; , mfa } ] See Fields below. report_cb :: fun ((logger:report()) -&gt; [field()] Function that takes Prefix and Logger's report and returns list of 2-ary tuples where first one MUST contain only uppercase ASCII letters, digits and underscore characters, and must not start with underscore. Field name and second one is field value in form of iolist() . It is important to note that value can contain any data, and does not need to be in any encoding; it can even be binary. Example my_formatter ( Prefix , \#{ field := Field } ) when is_integer ( Field ) -&gt; [ { [ Prefix , &quot;_FIELD&quot; ] , io_lib : format ( &quot; ~.16B &quot; , [ Field ] } ] . Remember that all field names MUST NOT start with the underscore, otherwise journald can ignore them. Such behaviour is not enforced on data returned by report_cb and it is left up to the implementor to remember it. Fields Fields list contain definition of fields that will be presented in the log message fed into journald . Few of them have special meaning and you can see list of them in the systemd.journal-fields(7) manpage . Metakeys (i.e. atoms) in fields list will be sent to the journald as a uppercased atom names. Entries in form of {Name :: field_name(), logger_formatter:metakey()} will use Name as the field name. Name will be checked if it is correct journald field name (i.e. contains only ASCII letters, digits, and underscores, additionally do not start with underscore). Entries in form of {Name :: field_name(), Data :: iolist()} will use Name as field name and will contain Data as a literal. If entry data is empty or not set then it will be ommited in the output. Special fields Special fields availables: level Log level presented as string. priority Log level presented as decimal representation of syslog level. os_pid OS PID for current Erlang process. This is NOT Erlang PID . mfa Calling function presented in form Module:Function/Arity . time Timestamp of log message presented in RFC3339 format in UTC. script_id String in form of {Name} {Vsn} where Name and Vsn are replaced by 1st and 2nd value in tuple returned by init:script_id() Otherwise field is treated as a entry key where key is equivalent of [key] and is used as a list of atoms to extract data from the metadata map. Syslog compatibility To provide better compatibility and user convinience: syslog_pid Will work exactly the same as {&quot;SYSLOG_PID&quot;, os_pid} . syslog_timestamp Will work exactly the same as {&quot;SYSLOG_TIMESTAMP&quot;, time} . syslog_identifier Will work exactly the saem as {&quot;SYSLOG_IDENTIFIER&quot;, script_id} .","ref":"systemd_journal_h.html","title":"systemd_journal_h","type":"module"},{"doc":"","ref":"systemd_journal_h.html#t:field_definition/0","title":"systemd_journal_h.field_definition/0","type":"type"},{"doc":"","ref":"systemd_journal_h.html#t:field_name/0","title":"systemd_journal_h.field_name/0","type":"type"},{"doc":"","ref":"systemd_journal_h.html#t:field_value/0","title":"systemd_journal_h.field_value/0","type":"type"},{"doc":"Formatter wrapper for systemd's journal level information. Journald uses log-level format similar to Linux's printk logging function. This simply adds special prefix to the message formatted by the formatter specified via parent option. Automatic registration This formatter will be automatically registered for all handlers that use logger_std_h with type set to one of standard_io or standard_error if the respective FDs point to journal that is pointed by JOURNAL_STREAM which is autometically set by systemd if one of the options StandardOutput or StandardError is set to journal . So if you are using default logger handler then all you need to do is to set StandardOutput = journal In your systemd.service(8) file, and this library will handle the rest. It is important that this formatter will still work poorly with multiline logs, if you are using such, then check out systemd_journal_h handler (which SHOULD NOT be used with this formatter). To disable this behaviour set auto_formatter option for systemd to false . Example logger : add_handler ( journal_stdout , logger_std_h , \#{ formatter =&gt; { systemd_kmsg_formatter , \#{ } } ) . Options parent &quot;Parent&quot; formatter that will be used as a &quot;main&quot; formatter. Defaults to logger_formatter . Rest of the options will be passed to parent with this option removed.","ref":"systemd_kmsg_formatter.html","title":"systemd_kmsg_formatter","type":"module"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS Copyright 2019, Łukasz Niemier &lt;lukasz@niemier.pl&gt;. Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Simple library for notifying systemd about process state.","ref":"readme.html","title":"systemd","type":"extras"},{"doc":"NOTIFY_SOCKET communication with supervising process. Watchdog process will be started automatically (if not disabled). It will also handle sending keep-alive messages automatically. Fetching file descritors passed by the supervisor. journal logger handler and formatters.","ref":"readme.html#features","title":"systemd - Features","type":"extras"},{"doc":"Just add this to your rebar.config : { deps , [ systemd ] } . Or in case of Mix project, to your mix.exs : defp deps do [ { :systemd , &quot;~&gt; 0.6&quot; } ] end Then call systemd:notify(ready) when your application is ready to work/accept connections or add systemd:ready() as a child of your application's main supervisor. Non-systemd systems This application and all functions within are safe to call even in non-systemd and non-Linux OSes. In case if there is no systemd configuration options then all functions will simply work as (almost) no-ops.","ref":"readme.html#installation","title":"systemd - Installation","type":"extras"},{"doc":"Assuming you have my_app.service unit like that [Unit] Description=My Awesome App [Service] User=appuser Group=appgroup # This will allow using `systemd:notify/1` for informing the system supervisor # about application status. Type=notify # Application need to start in foreground instead of forking into background, # otherwise it may be not correctly detected and system will try to start it # again. ExecStart=/path/to/my_app start # Enable watchdog process, which will expect messages in given timeframe, # otherwise it will restart the process as a defunct. It should be managed # automatically by `systemd` application in most cases and will send messages # twice as often as requested. # # You can force failure by using `systemd:watchdog(trigger)` or manually ping # systemd watchdog via `systemd:watchdog(ping)`. WatchdogSec=10s Restart=on-failure [Install] WantedBy=multi-user.target You can inform systemd about state of your application. To do so just call: % Erlang systemd : notify ( ready ) . # Elixir :systemd . notify ( :ready ) This will make systemctl start my_app.service to wait until application is up and running. If you want to restart your application you can notify systemd about it with: % Erlang systemd : notify ( reloading ) . # Elixir :systemd . notify ( :reloading ) Message about application shutting down will be handled automatically for you. For simplification of readiness notification there is systemd:ready() function that returns child specs for temporary process that can be used as a part of your supervision tree to mark the point when application is ready, ex.: % Erlang - module ( my_app_sup ) . - behaviour ( supervisor ) . - export ( [ start_link / 1 , init / 1 ] ) . start_link ( Opts ) -&gt; supervisor : start_link ( { local , ? MODULE } , ? MODULE , Opts ) . init ( _ Opts ) -&gt; SupFlags = \#{ strategy =&gt; one_for_one } , Children = [ my_app_db : child_spec ( ) , my_app_webserver : child_spec ( ) , systemd : ready ( ) , my_app_periodic_job : child_spec ( ) ] , { ok , { SupFlags , Children } } . # Elixir defmodule MyProject.Application do use Application def start ( _type , _opts ) do children = [ MyProject.Repo , MyProjectWeb.Endpoint , :systemd . ready ( ) # &lt;- IMPORTANT - this is a function call (it returns the proper child spec) ] Supervisor . start_link ( children , strategy : :one_for_one ) end end Logs To handle logs you have 2 possible options: Output data to standard output or error with special prefixes. This approach is much simpler and straightforward, however do not support structured logging and multiline messages. Use datagram socket with special communication protocol. This requires a little bit more effort to set up, but seamlessly supports structured logging and multiline messages. This library supports both formats, and it is up to You which one (or both?) your app will decide to use. Erlang Standard error There is systemd_kmsg_formatter which formats data using kmsg -like level prefixes can be used with any logger that outputs to standard output or standard error if this is attached to the journal. By default systemd library will update all handlers that use logger_std_h with type standard_io or standard_error that are attached to the journal (it is automatically detected via JOURNAL_STREAM environment variable). You can disable that behaviour by setting: % Erlang [ { systemd , [ { auto_formatter , false } ] } ] . For custom loggers you can use this formatter by adding new option parent to the formatter options that will be used as &quot;upstream&quot; formatter, ex.: logger : add_handler ( example_handler , logger_disk_log_h , \#{ formatter =&gt; { systemd_kmsg_formatter , \#{ parent =&gt; logger_formatter , template =&gt; [ msg ] } , config =&gt; \#{ file =&gt; &quot;/var/log/my_app.log&quot; } } ) . Datagram socket This one requires systemd application to be started to spawn some processes required for handling sockets, so the best way to handle it is to add predefined systemd handlers after your application starts: logger : add_handlers ( systemd ) , logger : remove_handler ( default ) . Be aware that this one is not guaranteed to work on non-systemd systems, so if You aren't sure if that application will be ran on systemd-enabled OS then you shouldn't use it as an only logger solution in your application or you can end with no logger attached at all. This handler should not be used with systemd_kmsg_formatter as this will result with pointless kmsg -like prefixes in the log messages. You can also &quot;manually&quot; configgure handler if you want to configure formatter: logger : add_handler ( my_handler , systemd_journal_h , \#{ formatter =&gt; { my_formatter , FormatterOpts } } ) , logger : remove_handler ( default ) . Elixir This assumes Elixir 1.10+, as earlier versions do not use Erlang's logger module for dispatching logs. Standard error systemd has Erlang's logger backend, which mean that you have 2 ways of achieving what is needed: Disable Elixir's backends and just rely on default Erlang's handler: # config/config.exs config :logger , backends : [ ] , handle_otp_reports : false , handle_sasl_reports : false And then allow systemd to make its magic that is used in &quot;regular&quot; Erlang code. &quot;Manually&quot; add handler that will use systemd_kmsg_formatter : # In application start/2 callback :ok = :logger . add_handler ( :my_handler , :logger_std_h , %{ formatter : { :systemd_kmsg_formatter , %{ } } } ) Logger . remove_backend ( :console ) However remember, that currently (as Elixir 1.11) there is no &quot;Elixir formatter&quot; for Erlang's logger implementation, so you can end with Erlang-style formatting of the metadata in the logs. Datagram socket You can use Erlang-like approach, which is: # In application start/2 callback :logger . add_handlers ( :systemd ) Logger . remove_backend ( :console ) Or you can manually configure the handler: # In application start/2 callback :logger . add_handler ( :my_handler , :systemd_journal_h , %{ formatter : { MyFormatter , formatter_opts } } ) Logger . remove_backend ( :console ) Be aware that this one is not guaranteed to work on non-systemd systems, so if You aren't sure if that application will be ran on systemd-enabled OS then you shouldn't use it as an only logger solution in your application or you can end with no logger attached at all. This handler should not be used with :systemd_kmsg_formatter as this will result with pointless kmsg -like prefixes in the log messages.","ref":"readme.html#usage","title":"systemd - Usage","type":"extras"},{"doc":"See LICENSE .","ref":"readme.html#license","title":"systemd - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"CHANGELOG - Unreleased","type":"extras"},{"doc":"Bug Fixes docs for systemd_journal_h ( 9979ba5 ) Documentation add syntax highlighting on systemd example ( a580cab ) Features add functions to set custom status ( 9342d36 )","ref":"changelog.html#v0-6-2-2021-12-30","title":"CHANGELOG - v0.6.2 - 2021-12-30","type":"extras"},{"doc":"Bug Fixes Add Erlang 24 support ( #29 ) ( 2588664 ) do not fail on invalid JOURNAL_STREAM content ( 0ce748e ) add enough to list of required applications ( 937ef70 ) systemd_journal_h: Support literal field values ( #25 ) ( 7a1b9a7 ) systemd_protocol: keep empty values in encode_field/2 ( #27 ) ( e732727 )","ref":"changelog.html#v0-6-1-2021-05-21","title":"CHANGELOG - v0.6.1 - 2021-05-21","type":"extras"},{"doc":"Bug Fixes journal_h: use proper check for socket existence ( 20b048e ) kmsg_formatter: do not append log level on last newline ( 4e52c0f )","ref":"changelog.html#0-6-0-2021-03-12","title":"CHANGELOG - 0.6.0 - 2021-03-12","type":"extras"},{"doc":"Bug Fixes journal: use correct name for priority attribute ( 9493d35 )","ref":"changelog.html#0-5-3-2021-01-04","title":"CHANGELOG - 0.5.3 - 2021-01-04","type":"extras"},{"doc":"Bug Fixes journal: format message as Unicode-encoded binary ( 1614c7c )","ref":"changelog.html#0-5-2-2021-01-04","title":"CHANGELOG - 0.5.2 - 2021-01-04","type":"extras"},{"doc":"Bug Fixes journal: cleanup journal documentation ( 3b6bf5a ) Documentation describe usage in Elixir projects ( ff67d80 ) fix typo equested -&gt; requested ( 5949441 ) imporve systemd.service example in the README ( cd1b697 ) fds: document new functions ( 0e782a6 )","ref":"changelog.html#0-5-1-2021-01-04","title":"CHANGELOG - 0.5.1 - 2021-01-04","type":"extras"},{"doc":"Bug Fixes remove unneeded handle_info/2 callbacks ( fa77f8e ) Documentation update README ( 33cce22 ) fix typos in documentation ( 6a40613 ) systemd_kmsg_formatter: add documentation about auto registration ( 4ecc76d )","ref":"changelog.html#0-5-0-2020-03-09","title":"CHANGELOG - 0.5.0 - 2020-03-09","type":"extras"},{"doc":"Bug Fixes systemd_stderr_formatter: prefix all lines instead of only first one ( 1ccd500 ) Documentation add since documentation tags ( abc7f28 ) expand documentation on systemd and systemd_journal_formatter ( f6e323c ) systemd: expand documentation of unset_env/1 ( 630460e ) systemd_stderr_formatter: hide implementation functions ( f670d1f )","ref":"changelog.html#0-4-0-2020-01-20","title":"CHANGELOG - 0.4.0 - 2020-01-20","type":"extras"},{"doc":"Bug Fixes systemd_journal_formatter: check for empty data before building iolist ( 095088e ) systemd_journal_formatter: again invalid format of multiline messages ( b8f213a )","ref":"changelog.html#0-3-3-2020-01-18","title":"CHANGELOG - 0.3.3 - 2020-01-18","type":"extras"},{"doc":"Bug Fixes systemd_journal_formatter: improper multiline format ( 2c821e5 )","ref":"changelog.html#0-3-2-2020-01-18","title":"CHANGELOG - 0.3.2 - 2020-01-18","type":"extras"},{"doc":"Bug Fixes systemd_journal_formatter: handling of unary report_cb return value ( 4a0577b )","ref":"changelog.html#0-3-1-2020-01-18","title":"CHANGELOG - 0.3.1 - 2020-01-18","type":"extras"},{"doc":"Bug Fixes move environment variables extraction to supervisor ( d889d67 ) systemd_watchdog: convert timeout from microseconds to milliseconds ( fec0e26 ) systemd_watchdog: use send_after instead of timeouts ( c85c095 ) systemd_watchdog: initial timeout was off ( d8839b7 ) Documentation add informations about journal loggers ( 20718cc ) README: extend example with more correct systemd service ( ab3c3fa ) systemd_formatter: document usage ( 5c3e3ba ) systemd_journal_h: add warnings about required formatter ( 3e09c7c ) systemd_stderr_formatter: fix missing tag ( 31f1b60 )","ref":"changelog.html#0-3-0-2020-01-18","title":"CHANGELOG - 0.3.0 - 2020-01-18","type":"extras"},{"doc":"Bug Fixes systemd_watchdog: convert time unit from micro to milliseconds ( 2a40a6e )","ref":"changelog.html#0-1-2-2020-01-15","title":"CHANGELOG - 0.1.2 - 2020-01-15","type":"extras"},{"doc":"Bug Fixes systemd_watchdog: convert timeout from microseconds to milliseconds ( fec0e26 ) systemd_watchdog: use send_after instead of timeouts ( c85c095 ) systemd_watchdog: initial timeout was off ( d8839b7 )","ref":"changelog.html#0-2-0-2020-01-15","title":"CHANGELOG - 0.2.0 - 2020-01-15","type":"extras"},{"doc":"Bug Fixes systemd_app: remove start_phase ( a9e5905 ) systemd_socket: unused variable ( 1d51b2e ) systemd_watchdog: one missed direct call to socket ( 0fce8eb )","ref":"changelog.html#0-1-1-2020-01-15","title":"CHANGELOG - 0.1.1 - 2020-01-15","type":"extras"},{"doc":"","ref":"changelog.html#0-1-0-2020-01-15","title":"CHANGELOG - 0.1.0 - 2020-01-15","type":"extras"}]